C
C
C  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.
C
C  This program is free software; you can redistribute it and/or modify it
C  under the terms of version 2.1 of the GNU Lesser General Public License 
C  as published by the Free Software Foundation.
C
C  This program is distributed in the hope that it would be useful, but
C  WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
C
C  Further, this software is distributed without any warranty that it is
C  free of the rightful claim of any third person regarding infringement 
C  or the like.  Any license provided herein, whether implied or 
C  otherwise, applies only to this software file.  Patent licenses, if
C  any, provided herein do not apply to combinations of this program with 
C  other software, or any other product whatsoever.  
C
C  You should have received a copy of the GNU Lesser General Public 
C  License along with this program; if not, write the Free Software 
C  Foundation, Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, 
C  USA.
C
C  Contact information:  Silicon Graphics, Inc., 1600 Amphitheatre Pky,
C  Mountain View, CA 94043, or:
C
C  http://www.sgi.com
C
C  For further information regarding this notice, see:
C
C  http://oss.sgi.com/projects/GenInfo/NoticeExplan
C
C


      INTEGER FUNCTION TMATS(TABNUM, TABINC)
      IMPLICIT INTEGER (A-Z)
C
CDIR$ ID "@(#) libu/tblmgr/tmats.f	92.0	10/08/98 14:57:41"
C
C     TMATS   Allocate table space
C
C     Call:   INDEX = TMATS(TABNUM, TABINC)
C
C     Entry:  TABNUM contains the table number.
C             TABINC contains the number of words to add to the size
C             of the table.
C
C     Exit:   INDEX contains the zero-based index of the new area in
C             the table.

      INCLUDE 'tblmgr.fh'

C     Validate number of arguments, NTAB, TABNUM, and TABINC.

      IF (NUMARG() .NE. 2) THEN
        CALL TMERR('TMATS', FETBARGS)
      ENDIF

      IF ((NTAB .LT. 1) .OR. (NTAB .GT. 64)) THEN
        CALL TMERR('TMATS', FETBNTAB)
      ENDIF

      IF ((TABNUM .LT. 1) .OR. (TABNUM .GT. NTAB)) THEN
        CALL TMERR('TMATS', FETBTNUM)
      ENDIF

      IF ((LTAB(TABNUM) + TABINC) .LT. 0) THEN
        CALL TMERR('TMATS', FETBINCR)
      ENDIF

C     Set INDEX and new length.

      INDEX = LTAB(TABNUM)
      LTAB(TABNUM) = LTAB(TABNUM) + TABINC

C     See if the increment can be satisfied from the pad area, or if
C     we need the heap manager's help.

      ACTPAD = ALEN(TABNUM) - LTAB(TABNUM)

      IF ((ACTPAD .GT. PAD(TABNUM)) .OR. (ACTPAD .LT. 0)) THEN
        CALL TMPTC
      ENDIF

C     Set return value.

      TMATS = INDEX

      RETURN
      END
